import { Agent as HttpAgent } from 'node:http';
import { Agent as HttpsAgent, AgentOptions } from 'node:https';
import { Agent as UndiciAgentType, ProxyAgent as UndiciProxyAgentType } from 'undici';

type FetchEnhancedRequestInput = string | URL;
type AnyAgent = UndiciProxyAgentType | UndiciAgentType | HttpAgent | HttpsAgent;
type AgentOpts = AgentOptions & {
    noProxy?: boolean;
};
type ModuleOpts = {
    undici: boolean;
    agentCacheSize?: number;
};
type FetchOpts = RequestInit & {
    timeout?: number;
    agent?: AnyAgent;
    dispatcher?: AnyAgent;
    agentOpts?: AgentOpts;
};
export declare class TimeoutError extends Error {
    constructor(message: string);
}
export default function fetchEnhanced(fetchImplementation: any, { undici, agentCacheSize }?: ModuleOpts): {
    (url: FetchEnhancedRequestInput, { timeout, agentOpts, ...opts }?: FetchOpts): Promise<Response>;
    clearCache(): void;
};
export {};
