var __accessCheck = (obj, member, msg) => {
  if (!member.has(obj))
    throw TypeError("Cannot " + msg);
};
var __privateGet = (obj, member, getter) => {
  __accessCheck(obj, member, "read from private field");
  return getter ? getter.call(obj) : member.get(obj);
};
var __privateAdd = (obj, member, value) => {
  if (member.has(obj))
    throw TypeError("Cannot add the same private member more than once");
  member instanceof WeakSet ? member.add(obj) : member.set(obj, value);
};
var __privateSet = (obj, member, value, setter) => {
  __accessCheck(obj, member, "write to private field");
  setter ? setter.call(obj, value) : member.set(obj, value);
  return value;
};
var __privateWrapper = (obj, member, setter, getter) => ({
  set _(value) {
    __privateSet(obj, member, value, setter);
  },
  get _() {
    return __privateGet(obj, member, getter);
  }
});
var __privateMethod = (obj, member, method) => {
  __accessCheck(obj, member, "access private method");
  return method;
};
var _size, _cache, _oldCache, _maxSize, _maxAge, _onEviction, _emitEvictions, emitEvictions_fn, _deleteIfExpired, deleteIfExpired_fn, _getOrDeleteIfExpired, getOrDeleteIfExpired_fn, _getItemValue, getItemValue_fn, _peek, peek_fn, _set, set_fn, _moveToRecent, moveToRecent_fn, _entriesAscending, entriesAscending_fn;
import require$$0 from "https";
import require$$1 from "http";
import require$$2 from "url";
import { Agent as Agent$1 } from "node:http";
import { Agent } from "node:https";
function getDefaultExportFromCjs(x) {
  return x && x.__esModule && Object.prototype.hasOwnProperty.call(x, "default") ? x["default"] : x;
}
const https = require$$0;
const http = require$$1;
const { URL: URL$1 } = require$$2;
let HttpProxyAgent$1 = class HttpProxyAgent extends http.Agent {
  constructor(options) {
    const { proxy, proxyRequestOptions, ...opts } = options;
    super(opts);
    this.proxy = typeof proxy === "string" ? new URL$1(proxy) : proxy;
    this.proxyRequestOptions = proxyRequestOptions || {};
  }
  createConnection(options, callback) {
    const requestOptions = {
      ...this.proxyRequestOptions,
      method: "CONNECT",
      host: this.proxy.hostname,
      port: this.proxy.port,
      path: `${options.host}:${options.port}`,
      setHost: false,
      headers: { ...this.proxyRequestOptions.headers, connection: this.keepAlive ? "keep-alive" : "close", host: `${options.host}:${options.port}` },
      agent: false,
      timeout: options.timeout || 0
    };
    if (this.proxy.username || this.proxy.password) {
      const base64 = Buffer.from(`${decodeURIComponent(this.proxy.username || "")}:${decodeURIComponent(this.proxy.password || "")}`).toString("base64");
      requestOptions.headers["proxy-authorization"] = `Basic ${base64}`;
    }
    if (this.proxy.protocol === "https:") {
      requestOptions.servername = this.proxy.hostname;
    }
    const request = (this.proxy.protocol === "http:" ? http : https).request(requestOptions);
    request.once("connect", (response, socket, head) => {
      request.removeAllListeners();
      socket.removeAllListeners();
      if (response.statusCode === 200) {
        callback(null, socket);
      } else {
        socket.destroy();
        callback(new Error(`Bad response: ${response.statusCode}`), null);
      }
    });
    request.once("timeout", () => {
      request.destroy(new Error("Proxy timeout"));
    });
    request.once("error", (err) => {
      request.removeAllListeners();
      callback(err, null);
    });
    request.end();
  }
};
let HttpsProxyAgent$1 = class HttpsProxyAgent extends https.Agent {
  constructor(options) {
    const { proxy, proxyRequestOptions, ...opts } = options;
    super(opts);
    this.proxy = typeof proxy === "string" ? new URL$1(proxy) : proxy;
    this.proxyRequestOptions = proxyRequestOptions || {};
  }
  createConnection(options, callback) {
    const requestOptions = {
      ...this.proxyRequestOptions,
      method: "CONNECT",
      host: this.proxy.hostname,
      port: this.proxy.port,
      path: `${options.host}:${options.port}`,
      setHost: false,
      headers: { ...this.proxyRequestOptions.headers, connection: this.keepAlive ? "keep-alive" : "close", host: `${options.host}:${options.port}` },
      agent: false,
      timeout: options.timeout || 0
    };
    if (this.proxy.username || this.proxy.password) {
      const base64 = Buffer.from(`${decodeURIComponent(this.proxy.username || "")}:${decodeURIComponent(this.proxy.password || "")}`).toString("base64");
      requestOptions.headers["proxy-authorization"] = `Basic ${base64}`;
    }
    if (this.proxy.protocol === "https:") {
      requestOptions.servername = this.proxy.hostname;
    }
    const request = (this.proxy.protocol === "http:" ? http : https).request(requestOptions);
    request.once("connect", (response, socket, head) => {
      request.removeAllListeners();
      socket.removeAllListeners();
      if (response.statusCode === 200) {
        const secureSocket = super.createConnection({ ...options, socket });
        callback(null, secureSocket);
      } else {
        socket.destroy();
        callback(new Error(`Bad response: ${response.statusCode}`), null);
      }
    });
    request.once("timeout", () => {
      request.destroy(new Error("Proxy timeout"));
    });
    request.once("error", (err) => {
      request.removeAllListeners();
      callback(err, null);
    });
    request.end();
  }
};
var hpagent = {
  HttpProxyAgent: HttpProxyAgent$1,
  HttpsProxyAgent: HttpsProxyAgent$1
};
const mod = /* @__PURE__ */ getDefaultExportFromCjs(hpagent);
const HttpProxyAgent2 = mod.HttpProxyAgent;
const HttpsProxyAgent2 = mod.HttpsProxyAgent;
class QuickLRU extends Map {
  constructor(options = {}) {
    super();
    __privateAdd(this, _emitEvictions);
    __privateAdd(this, _deleteIfExpired);
    __privateAdd(this, _getOrDeleteIfExpired);
    __privateAdd(this, _getItemValue);
    __privateAdd(this, _peek);
    __privateAdd(this, _set);
    __privateAdd(this, _moveToRecent);
    __privateAdd(this, _entriesAscending);
    __privateAdd(this, _size, 0);
    __privateAdd(this, _cache, /* @__PURE__ */ new Map());
    __privateAdd(this, _oldCache, /* @__PURE__ */ new Map());
    __privateAdd(this, _maxSize, void 0);
    __privateAdd(this, _maxAge, void 0);
    __privateAdd(this, _onEviction, void 0);
    if (!(options.maxSize && options.maxSize > 0)) {
      throw new TypeError("`maxSize` must be a number greater than 0");
    }
    if (typeof options.maxAge === "number" && options.maxAge === 0) {
      throw new TypeError("`maxAge` must be a number greater than 0");
    }
    __privateSet(this, _maxSize, options.maxSize);
    __privateSet(this, _maxAge, options.maxAge || Number.POSITIVE_INFINITY);
    __privateSet(this, _onEviction, options.onEviction);
  }
  // For tests.
  get __oldCache() {
    return __privateGet(this, _oldCache);
  }
  get(key) {
    if (__privateGet(this, _cache).has(key)) {
      const item = __privateGet(this, _cache).get(key);
      return __privateMethod(this, _getItemValue, getItemValue_fn).call(this, key, item);
    }
    if (__privateGet(this, _oldCache).has(key)) {
      const item = __privateGet(this, _oldCache).get(key);
      if (__privateMethod(this, _deleteIfExpired, deleteIfExpired_fn).call(this, key, item) === false) {
        __privateMethod(this, _moveToRecent, moveToRecent_fn).call(this, key, item);
        return item.value;
      }
    }
  }
  set(key, value, { maxAge = __privateGet(this, _maxAge) } = {}) {
    const expiry = typeof maxAge === "number" && maxAge !== Number.POSITIVE_INFINITY ? Date.now() + maxAge : void 0;
    if (__privateGet(this, _cache).has(key)) {
      __privateGet(this, _cache).set(key, {
        value,
        expiry
      });
    } else {
      __privateMethod(this, _set, set_fn).call(this, key, { value, expiry });
    }
    return this;
  }
  has(key) {
    if (__privateGet(this, _cache).has(key)) {
      return !__privateMethod(this, _deleteIfExpired, deleteIfExpired_fn).call(this, key, __privateGet(this, _cache).get(key));
    }
    if (__privateGet(this, _oldCache).has(key)) {
      return !__privateMethod(this, _deleteIfExpired, deleteIfExpired_fn).call(this, key, __privateGet(this, _oldCache).get(key));
    }
    return false;
  }
  peek(key) {
    if (__privateGet(this, _cache).has(key)) {
      return __privateMethod(this, _peek, peek_fn).call(this, key, __privateGet(this, _cache));
    }
    if (__privateGet(this, _oldCache).has(key)) {
      return __privateMethod(this, _peek, peek_fn).call(this, key, __privateGet(this, _oldCache));
    }
  }
  delete(key) {
    const deleted = __privateGet(this, _cache).delete(key);
    if (deleted) {
      __privateWrapper(this, _size)._--;
    }
    return __privateGet(this, _oldCache).delete(key) || deleted;
  }
  clear() {
    __privateGet(this, _cache).clear();
    __privateGet(this, _oldCache).clear();
    __privateSet(this, _size, 0);
  }
  resize(newSize) {
    if (!(newSize && newSize > 0)) {
      throw new TypeError("`maxSize` must be a number greater than 0");
    }
    const items = [...__privateMethod(this, _entriesAscending, entriesAscending_fn).call(this)];
    const removeCount = items.length - newSize;
    if (removeCount < 0) {
      __privateSet(this, _cache, new Map(items));
      __privateSet(this, _oldCache, /* @__PURE__ */ new Map());
      __privateSet(this, _size, items.length);
    } else {
      if (removeCount > 0) {
        __privateMethod(this, _emitEvictions, emitEvictions_fn).call(this, items.slice(0, removeCount));
      }
      __privateSet(this, _oldCache, new Map(items.slice(removeCount)));
      __privateSet(this, _cache, /* @__PURE__ */ new Map());
      __privateSet(this, _size, 0);
    }
    __privateSet(this, _maxSize, newSize);
  }
  *keys() {
    for (const [key] of this) {
      yield key;
    }
  }
  *values() {
    for (const [, value] of this) {
      yield value;
    }
  }
  *[Symbol.iterator]() {
    for (const item of __privateGet(this, _cache)) {
      const [key, value] = item;
      const deleted = __privateMethod(this, _deleteIfExpired, deleteIfExpired_fn).call(this, key, value);
      if (deleted === false) {
        yield [key, value.value];
      }
    }
    for (const item of __privateGet(this, _oldCache)) {
      const [key, value] = item;
      if (!__privateGet(this, _cache).has(key)) {
        const deleted = __privateMethod(this, _deleteIfExpired, deleteIfExpired_fn).call(this, key, value);
        if (deleted === false) {
          yield [key, value.value];
        }
      }
    }
  }
  *entriesDescending() {
    let items = [...__privateGet(this, _cache)];
    for (let i = items.length - 1; i >= 0; --i) {
      const item = items[i];
      const [key, value] = item;
      const deleted = __privateMethod(this, _deleteIfExpired, deleteIfExpired_fn).call(this, key, value);
      if (deleted === false) {
        yield [key, value.value];
      }
    }
    items = [...__privateGet(this, _oldCache)];
    for (let i = items.length - 1; i >= 0; --i) {
      const item = items[i];
      const [key, value] = item;
      if (!__privateGet(this, _cache).has(key)) {
        const deleted = __privateMethod(this, _deleteIfExpired, deleteIfExpired_fn).call(this, key, value);
        if (deleted === false) {
          yield [key, value.value];
        }
      }
    }
  }
  *entriesAscending() {
    for (const [key, value] of __privateMethod(this, _entriesAscending, entriesAscending_fn).call(this)) {
      yield [key, value.value];
    }
  }
  get size() {
    if (!__privateGet(this, _size)) {
      return __privateGet(this, _oldCache).size;
    }
    let oldCacheSize = 0;
    for (const key of __privateGet(this, _oldCache).keys()) {
      if (!__privateGet(this, _cache).has(key)) {
        oldCacheSize++;
      }
    }
    return Math.min(__privateGet(this, _size) + oldCacheSize, __privateGet(this, _maxSize));
  }
  get maxSize() {
    return __privateGet(this, _maxSize);
  }
  entries() {
    return this.entriesAscending();
  }
  forEach(callbackFunction, thisArgument = this) {
    for (const [key, value] of this.entriesAscending()) {
      callbackFunction.call(thisArgument, value, key, this);
    }
  }
  get [Symbol.toStringTag]() {
    return JSON.stringify([...this.entriesAscending()]);
  }
}
_size = new WeakMap();
_cache = new WeakMap();
_oldCache = new WeakMap();
_maxSize = new WeakMap();
_maxAge = new WeakMap();
_onEviction = new WeakMap();
_emitEvictions = new WeakSet();
emitEvictions_fn = function(cache) {
  if (typeof __privateGet(this, _onEviction) !== "function") {
    return;
  }
  for (const [key, item] of cache) {
    __privateGet(this, _onEviction).call(this, key, item.value);
  }
};
_deleteIfExpired = new WeakSet();
deleteIfExpired_fn = function(key, item) {
  if (typeof item.expiry === "number" && item.expiry <= Date.now()) {
    if (typeof __privateGet(this, _onEviction) === "function") {
      __privateGet(this, _onEviction).call(this, key, item.value);
    }
    return this.delete(key);
  }
  return false;
};
_getOrDeleteIfExpired = new WeakSet();
getOrDeleteIfExpired_fn = function(key, item) {
  const deleted = __privateMethod(this, _deleteIfExpired, deleteIfExpired_fn).call(this, key, item);
  if (deleted === false) {
    return item.value;
  }
};
_getItemValue = new WeakSet();
getItemValue_fn = function(key, item) {
  return item.expiry ? __privateMethod(this, _getOrDeleteIfExpired, getOrDeleteIfExpired_fn).call(this, key, item) : item.value;
};
_peek = new WeakSet();
peek_fn = function(key, cache) {
  const item = cache.get(key);
  return __privateMethod(this, _getItemValue, getItemValue_fn).call(this, key, item);
};
_set = new WeakSet();
set_fn = function(key, value) {
  __privateGet(this, _cache).set(key, value);
  __privateWrapper(this, _size)._++;
  if (__privateGet(this, _size) >= __privateGet(this, _maxSize)) {
    __privateSet(this, _size, 0);
    __privateMethod(this, _emitEvictions, emitEvictions_fn).call(this, __privateGet(this, _oldCache));
    __privateSet(this, _oldCache, __privateGet(this, _cache));
    __privateSet(this, _cache, /* @__PURE__ */ new Map());
  }
};
_moveToRecent = new WeakSet();
moveToRecent_fn = function(key, item) {
  __privateGet(this, _oldCache).delete(key);
  __privateMethod(this, _set, set_fn).call(this, key, item);
};
_entriesAscending = new WeakSet();
entriesAscending_fn = function* () {
  for (const item of __privateGet(this, _oldCache)) {
    const [key, value] = item;
    if (!__privateGet(this, _cache).has(key)) {
      const deleted = __privateMethod(this, _deleteIfExpired, deleteIfExpired_fn).call(this, key, value);
      if (deleted === false) {
        yield item;
      }
    }
  }
  for (const item of __privateGet(this, _cache)) {
    const [key, value] = item;
    const deleted = __privateMethod(this, _deleteIfExpired, deleteIfExpired_fn).call(this, key, value);
    if (deleted === false) {
      yield item;
    }
  }
};
var parseUrl = require$$2.parse;
var DEFAULT_PORTS = {
  ftp: 21,
  gopher: 70,
  http: 80,
  https: 443,
  ws: 80,
  wss: 443
};
var stringEndsWith = String.prototype.endsWith || function(s) {
  return s.length <= this.length && this.indexOf(s, this.length - s.length) !== -1;
};
function getProxyForUrl(url) {
  var parsedUrl = typeof url === "string" ? parseUrl(url) : url || {};
  var proto = parsedUrl.protocol;
  var hostname = parsedUrl.host;
  var port = parsedUrl.port;
  if (typeof hostname !== "string" || !hostname || typeof proto !== "string") {
    return "";
  }
  proto = proto.split(":", 1)[0];
  hostname = hostname.replace(/:\d*$/, "");
  port = parseInt(port) || DEFAULT_PORTS[proto] || 0;
  if (!shouldProxy(hostname, port)) {
    return "";
  }
  var proxy = getEnv("npm_config_" + proto + "_proxy") || getEnv(proto + "_proxy") || getEnv("npm_config_proxy") || getEnv("all_proxy");
  if (proxy && proxy.indexOf("://") === -1) {
    proxy = proto + "://" + proxy;
  }
  return proxy;
}
function shouldProxy(hostname, port) {
  var NO_PROXY = (getEnv("npm_config_no_proxy") || getEnv("no_proxy")).toLowerCase();
  if (!NO_PROXY) {
    return true;
  }
  if (NO_PROXY === "*") {
    return false;
  }
  return NO_PROXY.split(/[,\s]/).every(function(proxy) {
    if (!proxy) {
      return true;
    }
    var parsedProxy = proxy.match(/^(.+):(\d+)$/);
    var parsedProxyHostname = parsedProxy ? parsedProxy[1] : proxy;
    var parsedProxyPort = parsedProxy ? parseInt(parsedProxy[2]) : 0;
    if (parsedProxyPort && parsedProxyPort !== port) {
      return true;
    }
    if (!/^[.*]/.test(parsedProxyHostname)) {
      return hostname !== parsedProxyHostname;
    }
    if (parsedProxyHostname.charAt(0) === "*") {
      parsedProxyHostname = parsedProxyHostname.slice(1);
    }
    return !stringEndsWith.call(hostname, parsedProxyHostname);
  });
}
function getEnv(key) {
  return process.env[key.toLowerCase()] || process.env[key.toUpperCase()] || "";
}
var getProxyForUrl_1 = getProxyForUrl;
const defaultAgentOpts = {
  maxSockets: 64,
  keepAlive: false
};
class TimeoutError extends Error {
  constructor(message) {
    var _a;
    super(message);
    this.name = "TimeoutError";
    (_a = Error.captureStackTrace) == null ? void 0 : _a.call(Error, this, TimeoutError);
  }
}
const inputToUrl = (url) => url instanceof URL ? url : new URL(url);
const inputToStr = (url) => url instanceof URL ? String(url) : url;
function fetchEnhanced(fetchImplementation, { undici = false, agentCacheSize = 512 } = { undici: false }) {
  const agentCache = new QuickLRU({ maxSize: agentCacheSize });
  async function getAgent(url, agentOpts = {}) {
    const { origin, protocol } = inputToUrl(url);
    const proxyUrl = (agentOpts == null ? void 0 : agentOpts.noProxy) ? null : getProxyForUrl_1(url);
    const agentCacheKey = JSON.stringify({ proxyUrl, origin, ...agentOpts });
    if (agentCache.has(agentCacheKey))
      return agentCache.get(agentCacheKey);
    let agent;
    if ("noProxy" in agentOpts)
      delete agentOpts.noProxy;
    if (undici) {
      const undiciOpts = { ...agentOpts };
      if ("keepAlive" in undiciOpts && !("pipelining" in undiciOpts)) {
        undiciOpts.pipelining = undiciOpts.keepAlive ? 1 : 0;
      }
      if ("keepAlive" in undiciOpts) {
        delete undiciOpts.keepAlive;
      }
      if ("maxSockets" in undiciOpts && typeof undiciOpts.maxSockets === "number") {
        undiciOpts.connections = undiciOpts.maxSockets;
        delete undiciOpts.maxSockets;
      }
      let UndiciProxyAgent;
      let UndiciAgent;
      let hadError = false;
      try {
        ({ ProxyAgent: UndiciProxyAgent, Agent: UndiciAgent } = await import("undici"));
      } catch {
        hadError = true;
      }
      if (proxyUrl && hadError) {
        throw new Error(`Please install the "undici" package to enable proxy support`);
      }
      if (proxyUrl && UndiciProxyAgent) {
        agent = new UndiciProxyAgent({ ...undiciOpts, uri: proxyUrl });
      } else if (UndiciAgent) {
        agent = new UndiciAgent(undiciOpts);
      }
    } else {
      const isHttps = protocol === "https:";
      if (proxyUrl) {
        agent = new (isHttps ? HttpsProxyAgent2 : HttpProxyAgent2)({ ...agentOpts, proxy: proxyUrl });
      } else {
        agent = new (isHttps ? Agent : Agent$1)(agentOpts);
      }
    }
    agentCache.set(agentCacheKey, agent);
    return agent;
  }
  const fetch = (url, { timeout = 0, agentOpts = {}, ...opts } = {}) => {
    return new Promise(async (resolve, reject) => {
      var _a;
      if (!undici && !("agent" in opts)) {
        const agent = await getAgent(url, { ...defaultAgentOpts, ...agentOpts });
        if (agent)
          opts.agent = agent;
      } else if (undici && !("dispatcher" in opts)) {
        const agent = await getAgent(url, { ...defaultAgentOpts, ...agentOpts });
        if (agent)
          opts.dispatcher = agent;
      }
      let timeoutId;
      let controller;
      if (timeout) {
        if (!("signal" in opts) && globalThis.AbortController) {
          controller = new AbortController();
          opts.signal = controller.signal;
        }
        timeoutId = setTimeout(() => {
          var _a2;
          (_a2 = controller == null ? void 0 : controller.abort) == null ? void 0 : _a2.call(controller);
          const err = new TimeoutError(`${opts.method || "GET"} ${inputToStr(url)} timed out after ${timeout}ms`);
          reject(err);
        }, timeout);
        (_a = timeoutId == null ? void 0 : timeoutId.unref) == null ? void 0 : _a.call(timeoutId);
      }
      fetchImplementation(url, opts).then((res) => {
        if (timeoutId)
          clearTimeout(timeoutId);
        resolve(res);
      }).catch((err) => {
        if (timeoutId)
          clearTimeout(timeoutId);
        if (err.name === "AbortError")
          return resolve(new Response());
        reject(err);
      });
    });
  };
  fetch.clearCache = () => {
    for (const agent of agentCache.values()) {
      if ("destroy" in agent)
        agent.destroy();
    }
    agentCache.clear();
  };
  return fetch;
}
export {
  TimeoutError,
  fetchEnhanced as default
};
